1 'BEAR-DST.BAS   mods. Barns 11/10/96  rev. 5/17/97 6/3/97 7/10/97

2 '   pretty thoroughly checked at dists. > 100 mi. Barns 11/11/96

3 '  user's lat. & lon. in lines 225 and 245--if changed, also chg. ln 268

4 '  uncorr. rel. sig. should agree with re-event.bas & cnss.bas

10 ' appends current calc. to file BEAR-DST.OUT

100 AIM = 345    'direction of max. sensitivity of Barn's Lehman 7/10/97

115     ' Great Circle.  This program is used to determine bearing

120     ' and range to a station given the latitude and longitude

125     ' of both stations.

135     ' Ver 1.02 Public Domain (p) November 1989 By S. R. Sampson, N5OWK

150     ' Ref: Air Force Manual 51-40, "Air Navigation", 1 February 1987

160     RADIAN = (180 / 3.14159)

165     GOTO 210

185     '

190     ACOS = -ATN(TMP / SQR(1 - TMP * TMP)) + 1.570796     '90/57.296

195     RETURN

200     '

205     ' Get the user data

210   KEY OFF: CLS : COLOR 7, 1, 2

215     PRINT "-----Input East Longitudes and South Latitudes as negative-----": PRINT

217  PRINT "     Latitudes must be < 90 deg & Longitudes < 180 deg ": PRINT

225     V1 = 40.68  'User's latitude

235     IF V1 > 90 OR V1 < -90 THEN 225

240     L1 = V1

245     V1 = 74.414   'User's longitude

255     IF V1 > 180 OR V1 < -180 THEN 245

260     A1 = V1

268  PRINT "Calc. from Martins La., 40.68 deg north, 74.414 deg west": PRINT

270     INPUT "    Latitude of destination [- if south] : ", V1: LATP = V1

280     IF V1 > 90 OR V1 < -90 THEN BEEP: GOTO 270

285     L2 = V1

290     INPUT "    Longitude of destination [- if east] : ", V1: LONP = V1

291 INPUT "Magnitude "; MAG$

292  IF V1 < 0 THEN GOTO 297   'E longitude

295  IF ABS(V1) >= 180 THEN V1 = -(360 - V1): PRINT "V1 = "; V1

297  IF ABS(V1) >= 180 THEN V1 = 360 + V1: PRINT "V1 = "; V1

300    'IF V1 > 180 OR V1 < -180 THEN BEEP:GOTO 290

305     A2 = V1

315     ' Compute the Bearing and Range, From the Formula in Chapter 23

325     DELTA = A2 - A1

335     ' Convert variables to Radians

345     L1 = L1 / RADIAN

350     A1 = A1 / RADIAN

355     L2 = L2 / RADIAN

360     DELTA = DELTA / RADIAN

365     TMP = (SIN(L1) * SIN(L2)) + (COS(L1) * COS(L2) * COS(DELTA))

370     GOSUB 190

375     DIST = ACOS

380     RANGE = 60 * (DIST * RADIAN) / .8684   'statute miles

385     TMP = (SIN(L2) - (SIN(L1) * COS(DIST))) / (SIN(DIST) * COS(L1))

390     GOSUB 190

395     BEARING = ACOS * RADIAN

400     IF DELTA > 0 THEN BEARING = 360 - BEARING

405     '

410     ' Computations complete, show answer

415  R = 1000 * SQR(5 * 3.141592) 'Sheetz radius of earth, miles

417  CIRCUM = 2 * 3.141592 * R:ANGDIST = 360 * (RANGE / CIRCUM)'circum. of earth

420     PRINT

425     PRINT "Bearing is "; BEARING; " deg."

427 PRINT : PRINT "  The distance is "; RANGE; " statute miles = "; " or "; 360 * (RANGE / CIRCUM); " deg."

430     PRINT

435 INPUT "USGS origin time UTC (hr:min:secs)"; ORGTIM$

437 GOSUB 700    'conv. orgtim$

440 USGS = HOUR * 60 + MINS + SECS / 60

480 PTRAV = 1.272 + .00256 * RANGE - 1.072E-07 * RANGE ^ 2'lst. sqs. fit to         P wave table.

490 PARR = USGS + PTRAV

500 PHR = PARR / 60: PHRS = INT(PHR): PMINS = (PHR - PHRS) * 60

510 PRINT : PRINT "Est.  P arrival at "; PHRS; " hrs "; : PRINT USING "###.# "; PMINS; : PRINT " mins."

511 ANGRANG = 360 * RANGE / CIRCUM

512 STRAV = 80.833 / 60 + 21.0177 / 60 * ANGRANG - .0673979 / 60 * ANGRANG ^ 2      'lst. sqs. fit to S wave table.

514 SARR = USGS + STRAV

516 SHR = SARR / 60: SHRS = INT(SHR): SMINS = (SHR - SHRS) * 60

518 PRINT "Est.  S arrival at "; SHRS; " hrs "; : PRINT USING "###.# "; SMINS; : PRINT " mins."

520 LQTRAV = (-1.766 + .45928 * RANGE) / 60  'eq. from lst. sqs. fit to LQ table

530 LQARR = USGS + LQTRAV

540 LQHR = LQARR / 60: LQHRS = INT(LQHR): LQMINS = (LQHR - LQHRS) * 60

550 PRINT "Est. LQ arrival at "; LQHRS; " hrs "; INT(LQMINS); " mins."

560 PRINT "   Time between P and LQ = "; : PRINT USING "###.# "; 60 * (LQHR - PHR); : PRINT " mins."

565   GOSUB 9000   'calc. rel. sig.

568 RSCORR = RELSIG * ABS((COS((BEARING - AIM) / RADIAN)))

569 PRINT "Rel. sig. = "; : PRINT USING "#######"; RELSIG: PRINT "Rel. sig. corr'd. for bearing = "; : PRINT USING "#######"; RSCORR

570      GOSUB 10000  'append to .OUT file

580 Q$ = INPUT$(1)   'any key

590 SYSTEM

700 'subr. to conv. ORGTIM$

710 FOR IC = 1 TO 20

720 CH$ = MID$(ORGTIM$, IC, 1)

730 IF CH$ = ":" THEN 760

740 HOUR$ = HOUR$ + CH$

750 NEXT IC

760 HOUR = VAL(HOUR$)

770 FOR IC1 = IC + 1 TO 20

780 CH$ = MID$(ORGTIM$, IC1, 1)

790 IF CH$ = ":" THEN 820

800 MINS$ = MINS$ + CH$

810 NEXT IC1

820 MINS = VAL(MINS$)

830 FOR IC2 = IC1 + 1 TO 20

840 CH$ = MID$(ORGTIM$, IC2, 1)

850 IF CH$ = ":" THEN 880

860 SECS$ = SECS$ + CH$

870 NEXT IC2

880 SECS = VAL(SECS$)

890 RETURN

9000 'rel. sig. subr. using ampl. curve in Aki & Richards, Fig. 10.8, p494

9002 'lin. interpolation of a ~log curve, sloppy but prob. OK

9010 RELSIG = (10 ^ (VAL(MAG$)) / RANGE) * 10'the old rel. sig

9020 IF ANGDIST < 10 THEN 9150    'no corr.

9030 IF ANGDIST > 20 THEN 9050    'between 10 and 20 deg

9040 RELSIG = RELSIG * 10 ^ (.11 / .12): GOTO 9150

9050 IF ANGDIST > 40 THEN 9070    'between 20 and 40 deg

9060 RELSIG = RELSIG * 10 ^ (.067 / .12): GOTO 9150

9070 IF ANGDIST > 80 THEN 9090

9080 RELSIG = RELSIG * 10 ^ (.022 / .12): GOTO 9150

9090 IF ANGDIST > 120 THEN 9110

9100 RELSIG = RELSIG * 10 ^ (.0075 / .12): GOTO 9150

9110 IF ANGDIST > 160 THEN 9140   'flat in this range

9120 RELSIG = RELSIG * 10 ^ (.0045 / .12): GOTO 9150

9140 RELSIG = RELSIG * 10 ^ (.0075 / .12)

9150 RETURN

10000 '   subr to append data to BEAR-DST.OUT

10010 OPEN "bear-dst.out" FOR APPEND AS #1

10020 PRINT #1, DATE$; " "; ORGTIM$; " "; : PRINT #1, TAB(23); MAG$; TAB(28);

10022 PRINT #1, "RS "; : PRINT #1, USING "######  "; RELSIG; : PRINT #1, "RS corr. "; : PRINT #1, USING "######"; RSCORR;

10030 'PRINT #1, USING "###### "; RELSIG;

10040 PRINT #1, USING "####.# "; LATP; LONP;

10050 PRINT #1, USING "##### "; RANGE;

10060 PRINT #1, USING "### "; 360 * (RANGE / CIRCUM): PRINT #1, "P";

10070 PRINT #1, USING "##:"; PHRS; : PRINT #1, USING "##.# "; PMINS; : PRINT #1, "S";

10080 PRINT #1, USING "##:"; SHR; : PRINT #1, USING "##.# "; SMINS; : PRINT #1, "LQ";

10090 PRINT #1, USING "##:"; LQHR; : PRINT #1, USING "##.# "; LQMINS;

10100 PRINT #1, "Bearing "; : PRINT #1, USING "#### "; BEARING

10110 CLOSE

10120 RETURN

